
function PDAnswer (number)
{
this.master=number;
this.roundingNumber=new PDRoundingNumber();
this.roundingNumber.setRoundingNumber(number);
this.bin=(Math.floor(number)).toString(2);
this.oct=(Math.floor(number)).toString(8);
this.hex=(Math.floor(number)).toString(16);
var self = this;
this.getAnswer=function(type)
{
switch(type) {
case 1: case 2: case 3: 
if (preferencesDecimalPlaces==-1) { 
return this.roundingNumber.roundToSignificantFigures(preferencesSignificantFigures);
} else {
return this.roundingNumber.roundToDecimal(preferencesDecimalPlaces);
}
break;
case 4:
if (preferencesDecimalPlaces==-1) { 
return formatPercentNumber(this.roundingNumber.roundToSignificantFigures(preferencesSignificantFigures));
} else {
return formatPercentNumber(this.roundingNumber.roundToDecimal(preferencesDecimalPlaces));
}
break;
case 5:
return formatBinaryNumber(this.bin);
break;
case 6:
return formatOctNumber(this.oct);
break;
case 7:
return formatHexNumber(this.hex);
break;
}
return 'error';
}
}
function PDNumber()
{
this.number=false;
if (arguments.length) {
this.number=parseFloat(arguments[0]);
if (isNaN(this.number))
this.number=false;
}
this.getNumber=function() {
return this.number;
}
}
function PDBlockInfo()
{
this.parent=false;
this.parentSubIndex=false; 
this.reduced=false;
this.reducedToNumber=false;
this.finished=false; 
this.setParent=function(number) {
this.parent=number;
}
this.setParentSubIndex=function(number) {
this.parentSubIndex=number;
}
this.setReduced=function(booleanValue) {
this.reduced=booleanValue;
}
this.setReducedToNumber=function(booleanValue) {
this.reducedToNumber=booleanValue;
}
this.getParent=function() {
return this.parent;
}
this.getParentSubIndex=function() {
return this.parentSubIndex;
}
this.getReduced=function() {
return this.reduced;
}
this.getReducedToNumber=function() {
return this.reducedToNumber;
}
this.markAsFinished=function() {
this.finished=true;
}
}
function PDBlock()
{
this.PDFunction=0;
this.operator=false;
this.negative=0;
this.number=false;
this.masterNumber=false;
this.PDVariablePointer=false;
this.justANumber=true; 
this.initialized=false;	
this.blockPointer=false; 
this.setOperator=function(operator) 
{
if (this.operator) { 
errorMessage='Error.';
} else {
this.operator=operator;
this.justANumber=false; 
this.initialized=true;	
}
}
this.setNumber=function(number) 
{
this.masterNumber=number;
this.number=parseFloat(number);
this.initialized=true;	
}
this.setPDVariablePointer=function(pointer)
{
this.PDVariablePointer=pointer;
this.initialized=true;	
}
this.resetNumber=function(number) 
{
this.masterNumber=number;
this.number=parseFloat(number);
this.negative=0;
this.initialized=true;
this.PDVariablePointer=false;
}
this.replaceWithPDBlockResult=function(number) 
{
this.masterNumber=number;
this.number=parseFloat(number);
this.initialized=true;
this.PDVariablePointer=false;
}
this.setPDFunction=function(number) 
{
this.PDFunction=number;
this.justANumber=false; 
this.initialized=true;	
}
this.getPDFunction=function(number) 
{
return this.PDFunction;
}
this.getNumber=function() 
{
if (this.PDVariablePointer!==false) { 
if (this.negative)
return (-1*(PDVariables[this.PDVariablePointer]).getValue());
return (PDVariables[this.PDVariablePointer]).getValue();
}
if (this.negative)
return (-1*this.number);
return this.number;
}
this.getOperator=function() 
{
return this.operator;
}
this.setBlockNegative=function() 
{
this.negative=1;
this.initialized=true;	
}
this.getBlockNegative=function() {
return this.negative;
}
this.setBlockPointer=function(number)
{
this.blockPointer=number;
this.initialized=true;	
}
this.getBlockPointer=function()
{
return this.blockPointer;
}
this.getMasterNumber=function()
{
if (this.negative)
return '-'+this.masterNumber;
return this.masterNumber;
}
this.isInitialized=function()
{
return this.initialized;
}	
this.isNumberOnly=function()
{
if (this.justANumber && this.number!==false)
return true;
return false;
}	
this.replaceWithResultOfPDFunction=function(result)
{
markBlockAsFinished(this.blockPointer); 
this.blockPointer=false;
this.PDFunction=0;
this.PDVariablePointer=false;
this.number=result;
this.masterNumber=result.toString();
}
this.getPDVariablePointer=function()
{
return this.PDVariablePointer;
}
}
function PDVariable()
{
this.locked=false;
this.value=false;
this.values=new Array();
this.definingEquation=false;
this.dependentVariables=new Array();
this.roundingNumber=new PDRoundingNumber();
this.getValue=function()
{
return this.value;
}
this.getValueForVariableHighlight=function()
{
return this.roundingNumber.roundToSignificantFigures(6, 1);
}
this.getValueForCache=function()
{
return this.roundingNumber.roundToSignificantFigures(4);
}
this.setValue=function(number)
{
this.value=number;
this.roundingNumber=new PDRoundingNumber();
this.roundingNumber.setRoundingNumber(number);
var i=(this.values).length;
this.values[i]=number;
}
}
function PDPosition()
{
this.mainIndex=0;
this.currentLocation=0;
this.setCurrentLocation=function(number)
{
this.currentLocation=number;	
}
this.setMainIndex=function(number)
{
this.mainIndex=number;	
}
this.getCurrentLocation=function()
{
return this.currentLocation;	
}
this.getMainIndex=function()
{
return this.mainIndex;	
}
}
function PDEvent()
{
this.time=false;
this.whatHappened=new Array();
}
function PDFormattingNumber()
{
this.negative=false;
this.masterNumber=false;
this.exponent=0;
this.beforeDecimal='';
this.afterDecimal='';
}
function PDFormulaForDisplay()
{
this.formula='';
this.entered=false;
this.dontTouch=false;
this.setFormula=function(formulaToSet)
{
this.formula=formulaToSet;
}
this.getFormula=function()
{
return this.formula;
}
this.setEntered=function(booleanValue)
{
this.entered=booleanValue;
}
this.getEntered=function()
{
return this.entered;
}
this.setDontTouch=function(booleanValue) {
this.dontTouch=booleanValue;
}
this.getDontTouch=function() {
return this.dontTouch;
}
}
function PDRoundingNumber () {
this.masterRoundingNumber=new Array();
this.masterDecimalLocation=-1;
this.masterExponent=0;
this.roundingNumber=new Array();
this.decimalLocation=-1
this.exponent=1;
this.negative='';
this.displayExponent=0;
this.setRoundingNumber = function(numberToSet) { 
var i, iStart=0, numberToSetString=numberToSet.toString();
var iEnd=numberToSetString.length;
var eLocation=numberToSetString.indexOf('e'); 
var encounteredInteger=0;
var originalDecimalLocation;
if (numberToSet<0) { 
iStart=1; 
this.negative='-';
} else if (numberToSet==0) { 
this.masterDecimalLocation=1;
this.masterExponent=0;
this.masterRoundingNumber.push(0);
return; 
}
if (eLocation!=-1) { 
this.masterExponent=parseInt(numberToSetString.substring(eLocation+1));
iEnd=eLocation; 
}
this.masterDecimalLocation=numberToSetString.indexOf('.');
if (this.masterDecimalLocation!=-1) {
originalDecimalLocation=this.masterDecimalLocation;
this.masterDecimalLocation-=iStart; 
numberToSetString=numberToSetString.replace('.', '');
iEnd--;
} else {
this.masterDecimalLocation=iEnd-iStart;
originalDecimalLocation=iEnd;
}
i=iStart;
if ((iEnd-iStart)>15) { 
iEnd=15+iStart;
}
while(numberToSetString.charAt(i)=='0') { 
if (i>=originalDecimalLocation) { 
this.masterExponent--;
} else { 
this.masterDecimalLocation--;
}
i++;
}
for (i=i; i<iEnd; i++) { 
this.masterRoundingNumber.push(numberToSetString.charCodeAt(i)-48);
}
this.removeTrailingZeros();
this.eliminateDoublePrecisionNoise();
}
this.eliminateDoublePrecisionNoise=function() {
var digitLimit=6;
var endLimit=3;
var repeatCount=0, i, startCount=1;
this.createMasterNumberCopy(); 
var localRoundingNumber=this.roundingNumber; 
var numberLength=this.roundingNumber.length;
for (i=this.decimalLocation; i<numberLength; i++) {
if (localRoundingNumber[i]==9) {
startCount=i;
repeatCount=0;
while (i<numberLength && localRoundingNumber[i]==9) {
i++;
repeatCount++;
}
i--; 
if (repeatCount>=digitLimit && (repeatCount+startCount)>=(numberLength-endLimit)) { 
this.truncateToLength(startCount);
this.masterRoundingNumber=this.roundingNumber.slice(); 
this.masterDecimalLocation=this.decimalLocation;
this.masterExponent=this.exponent;
return;				
}
} else if (localRoundingNumber[i]==0) { 
startCount=i;
repeatCount=0;
while (i<numberLength && localRoundingNumber[i]==0) {
i++;
repeatCount++;
}
i--; 
if (repeatCount>=digitLimit && (repeatCount+startCount)>=(numberLength-endLimit)) { 
this.truncateToLength(startCount);
this.masterRoundingNumber=this.roundingNumber.slice(); 
this.masterDecimalLocation=this.decimalLocation;
this.masterExponent=this.exponent;
return;				
}
}
}
}
this.roundToDecimal=function(decimalToRoundTo) { 
this.createMasterNumberCopy(); 
var localRoundingNumber=this.roundingNumber; 
var numberLength=localRoundingNumber.length;
var localAnswerFormatting=preferencesAnswerFormatting;
if (localAnswerFormatting==4) {
this.exponent+=2;
localAnswerFormatting=1;
}
var sciPonent=this.getSciPonent(); 
var digitsToRoundTo=0, engLength, zeroNumber;
this.displayExponent=1; 
if (localAnswerFormatting==2 || sciPonent>14) { 
digitsToRoundTo=1+decimalToRoundTo;
this.truncateToLength(digitsToRoundTo);
this.addZerosToEnd(digitsToRoundTo-localRoundingNumber.length); 
sciPonent=this.getSciPonent(); 
this.exponent=sciPonent;
this.decimalLocation=1;
} else if (localAnswerFormatting==3) { 
engLength=this.getEngLength(sciPonent);
digitsToRoundTo=decimalToRoundTo+engLength;
this.truncateToLength(digitsToRoundTo);
sciPonent=this.getSciPonent(); 
engLength=this.getEngLength(sciPonent);
digitsToRoundTo=decimalToRoundTo+engLength;
this.addZerosToEnd(digitsToRoundTo-localRoundingNumber.length); 
this.exponent=sciPonent-engLength+1;
this.decimalLocation=engLength;
} else { 
this.displayExponent=0; 
this.decimalLocation+=this.exponent;
this.exponent=0;
digitsToRoundTo=sciPonent+1+decimalToRoundTo;
this.truncateToLength(digitsToRoundTo);
sciPonent=this.getSciPonent();
if (sciPonent<0) {
digitsToRoundTo=1+decimalToRoundTo;
} else {
digitsToRoundTo=sciPonent+1+decimalToRoundTo;
}
zeroNumber=this.isZeroNumber();
if (zeroNumber) { 
digitsToRoundTo=1+decimalToRoundTo;
this.decimalLocation=1;
}
if (this.decimalLocation<=0) {
this.addZerosToBeginning(0-this.decimalLocation+1);
this.decimalLocation=1;
}
this.addZerosToEnd(digitsToRoundTo-this.roundingNumber.length);
}
if (this.decimalLocation==0) { 
this.addZerosToBeginning(1);
this.decimalLocation++;
}
return this.stringForNumber();
}
this.isZeroNumber=function() {
var i;
for (i=0; i<this.roundingNumber.length; i++) {
if (this.roundingNumber[i]!=0) {
return 0;
}
}
return 1;
}
this.roundToSignificantFigures = function(digitsToRoundTo) {
this.createMasterNumberCopy(); 
var localRoundingNumber=this.roundingNumber; 
var numberLength=localRoundingNumber.length;
var localAnswerFormatting=preferencesAnswerFormatting;
if (arguments.length==2) {
localAnswerFormatting=arguments[1];
}
var zeroNumber;
if (localAnswerFormatting==4) {
this.exponent=this.exponent+2;
localAnswerFormatting=1;
}
var sciPonent=this.getSciPonent(); 
var engLength;
this.displayExponent=1; 
if (digitsToRoundTo!=-1) { 
this.truncateToLength(digitsToRoundTo);
}
sciPonent=this.getSciPonent();
if (localAnswerFormatting==2 || (localAnswerFormatting==1 && (sciPonent>14 || sciPonent<-5))) { 
this.exponent=sciPonent;
this.decimalLocation=1;
this.removeTrailingZeros();
} else if (localAnswerFormatting==3) { 
engLength=this.getEngLength(sciPonent);
this.exponent=sciPonent+(1-engLength); 
this.decimalLocation=engLength;
this.removeTrailingZeros();
this.addZerosToEnd(engLength-localRoundingNumber.length); 
} else { 
this.displayExponent=0; 
zeroNumber=this.isZeroNumber();
if (zeroNumber) {
this.exponent=0;
} else if (sciPonent<0) { 
this.addZerosToBeginning(0-sciPonent);
this.decimalLocation=1;
this.exponent=0;
} else {
this.addZerosToEnd(sciPonent-localRoundingNumber.length+1); 
this.decimalLocation=sciPonent+1;
this.exponent=0;
}
}
return this.stringForNumber();
}
this.getNoiselessNumber=function() {
this.createMasterNumberCopy(); 
var localRoundingNumber=this.roundingNumber; 
var numberLength=localRoundingNumber.length;
var sciPonent=this.getSciPonent(); 
var tempString="", i;
if (numberLength==1) {
tempString=localRoundingNumber[0].toString();
} else {
tempString=localRoundingNumber[0].toString()+".";
}
for (i=1; i<numberLength; i++) {
tempString+=localRoundingNumber[i].toString();
}
tempString=tempString+"e"+sciPonent.toString();
return parseFloat(tempString);
}
this.createMasterNumberCopy=function() { 
this.decimalLocation=this.masterDecimalLocation;
this.exponent=this.masterExponent;
this.roundingNumber=this.masterRoundingNumber.slice(); 
}
this.printMasterRoundingNumber=function() { 
}
this.printRoundingNumber=function() { 
}
this.removeTrailingZeros=function() {
var zeroCount=0, i, lengthWanted;
i=this.masterRoundingNumber.length-1;
while (this.masterRoundingNumber[i]==0 && i>-1) {
i--;
zeroCount++;
}
if (zeroCount) {
if (zeroCount==this.masterRoundingNumber.length) { 
zeroCount--;
}
if (zeroCount<1) { 
return;
}
lengthWanted=this.masterRoundingNumber.length-zeroCount;
this.masterRoundingNumber.splice(lengthWanted, this.masterRoundingNumber.length-1);;
}
}
this.truncateToLength=function(lengthWanted) { 
var localRoundingNumber=this.roundingNumber; 
if (lengthWanted<localRoundingNumber.length && lengthWanted>0) { 
if (localRoundingNumber[lengthWanted]<5) { 
localRoundingNumber.splice(lengthWanted, localRoundingNumber.length-1);
} else { 
this.truncateWithRoundingToLength(lengthWanted); 
}
} else if (lengthWanted<0) { 
this.roundingNumber=new Array();
this.addZerosToBeginning(1);
this.exponent=0;
this.decimalLocation=1;
} else if (lengthWanted==0) {
if (localRoundingNumber[0]>4) {
this.roundingNumber=new Array();
this.roundingNumber.unshift(1);
this.decimalLocation++;
} else { 
this.roundingNumber=new Array();
this.addZerosToBeginning(1);
this.exponent=0;
this.decimalLocation=1;
}
}
}
this.truncateWithRoundingToLength=function(roundingLength) { 
var localRoundingNumber=this.roundingNumber; 
var i=roundingLength-1;
localRoundingNumber.splice(roundingLength, localRoundingNumber.length-roundingLength); 
while (i>-1 && ++localRoundingNumber[i]==10) {
localRoundingNumber[i]=0;
i--;
}
if (i==-1 && localRoundingNumber[0]==0) { 
localRoundingNumber.unshift(1); 
this.decimalLocation++; 
localRoundingNumber.pop(); 
}
}
this.addZerosToEnd=function(numberOfZerosToAdd) { 
var i;
for (i=0; i<numberOfZerosToAdd; i++) {
this.roundingNumber.push(0);
}
}
this.addZerosToBeginning=function(numberOfZerosToAdd) { 
var i;
for (i=0; i<numberOfZerosToAdd; i++) {
this.roundingNumber.unshift(0);
}		
}
this.getEngLength=function(sciPonent) { 
var engLength=0;
if (sciPonent>-1) {
engLength=sciPonent%3+1;
} else { 
engLength=3-(-1*sciPonent)%3; 
if (engLength==3) 
engLength=0;
engLength++;
}
return engLength;
}
this.getSciPonent=function() { 
return (this.exponent+this.decimalLocation-1);
}
this.stringForNumber = function() { 
var localRoundingNumber=this.roundingNumber; 
var i, numberString="", exponentString="";
numberString+=localRoundingNumber[0]; 
for (i=1; i<localRoundingNumber.length; i++) { 
if (preferencesThousandsSeperators && i<this.decimalLocation && ((this.decimalLocation-i)%3)==0) { 
numberString+=seperatorCharacter;
}
if (i==this.decimalLocation) {
numberString+=decimalCharacter;
}
numberString+=localRoundingNumber[i].toString(); 
}	
if (this.displayExponent || this.exponent!=0) {  
numberString=numberString+"e"+this.exponent;
}
if (parseFloat(numberString)==0) { 
return numberString;
}
return (this.negative + numberString);
}
}
